package xyz.mcutils.models.cache;

import lombok.Getter;
import lombok.ToString;
import xyz.mcutils.models.CachedResponse;
import xyz.mcutils.models.player.Cape;
import xyz.mcutils.models.player.Skin;

import java.util.UUID;

@Getter @ToString
public class CachedPlayer extends CachedResponse {

    /**
     * The UUID of the player
     */
    private UUID uniqueId;

    /**
     * The trimmed UUID of the player
     */
    private String trimmedUniqueId;

    /**
     * The username of the player
     */
    private String username;

    /**
     * The skin of the player, null if the
     * player does not have a skin
     */
    private Skin skin;

    /**
     * The cape of the player, null if the
     * player does not have a cape
     */
    private Cape cape;

    /**
     * The raw properties of the player
     */
    private ProfileProperty[] rawProperties;

    /**
     * A profile property for the player.
     */
    private static class ProfileProperty {
        /**
         * The name of the property.
         */
        private String name;

        /**
         * The base64 value of the property.
         */
        private String value;

        /**
         * Whether the property is signed.
         */
        private boolean signed;
    }
}
